--Colorize proclaim
function vexalarm_colorize_class(msg, spellid, colorize)
	local returnvalue = ""
	local alarmclass = ""
	
	if colorize == "spell" or colorize == "caster" then alarmclass = vexalarm_spells_defaults[tostring(spellid)][5] end
	
	if alarmclass == "" and colorize ~= "spell" then alarmclass = select(2, UnitClass(msg)) end
	
	if alarmclass == nil then alarmclass = "" end
	
	returnvalue = "|CFF"..vexalarm_parameters["colors"]["cc"][alarmclass]..msg.."|r"

	return returnvalue
end

function vexalarm_colorize_status(statustext, status)
	local returnvalue = ""
	if status then returnvalue="|CFF"..vexalarm_parameters["colors"]["active"]["HEX"]..""..statustext.."|r"
	else	 returnvalue="|CFF"..vexalarm_parameters["colors"]["inactive"]["HEX"]..statustext.."|r" end
	return returnvalue
end

function vexalarm_colorize_specific(msg, sub)
	local color = ""
	if 		sub == 1 then color = vexalarm_parameters["colors"]["caster_sc"]["HEX"]
	elseif 	sub == 2 then color = vexalarm_parameters["colors"]["target_sc"]["HEX"]
	else 				  color = vexalarm_parameters["colors"]["spell_sc"]["HEX"] end
	return "|CFF"..color..msg.."|r"
end

function vexalarm_spellcheck(auraID, player, eventchar)
	local totem = false
	local returnvalue = ""
	
	local auratocheck=tostring(auraID)

	--overflow check - check data
	local currenttime = time()
	local eventstring = ""
	if eventchar == "SPELL_CAST_SUCCESS" or eventchar == "SPELL_SUMMON" or eventchar == "SPELL_AURA_APPLIED" or eventchar == "SPELL_RESURRECT" then eventstring = "gain"
	else eventstring = "lost" end
		
	if vexalarm_spells_defaults[auratocheck] ~=nil then
		local temp = vexalarm_spells_defaults[auratocheck][6]
		
		if vexalarm_spells_defaults[auratocheck][6] ~= nil then totem = true end
		
		if ((eventchar == "SPELL_AURA_APPLIED" or eventchar == "SPELL_AURA_REMOVED" or (eventchar == "SPELL_SUMMON" and totem)) and (temp == "selfbuff" or temp == "buff" or temp == "grpbuff")) or
			((eventchar == "SPELL_CAST_SUCCESS" or eventchar == "SPELL_SUMMON" or eventchar == "SPELL_RESURRECT") and (temp == "instant" or temp == "instantself"))	then
			if vexalarm_spells[auratocheck][vexalarm_getplayerrole(player)] then returnvalue = temp end
		end
	end
	
	if auratocheck==vexalarm.last_spell_id and vexalarm.last_spell_timestamp+1>=currenttime and eventstring == vexalarm.last_spell_event then
		if returnvalue == "grpcheck" then returnvalue = "dejavue" 
		else
			if player==vexalarm.last_spell_caster then returnvalue = "dejavue" end
		end
	end
	
	--overflow check - update data
	if returnvalue ~= "" and returnvalue ~= "dejavue" then
		vexalarm.last_spell_id = auratocheck
		vexalarm.last_spell_timestamp = currenttime
		vexalarm.last_spell_event = eventstring
		vexalarm.last_spell_caster = player
	end
		
	return returnvalue
end

function vexalarm_check_fulltext()
	local currenttime = time()
	
	-- check and remove old proclaims
	local removes = 0
	if #vexalarm.proclaims ~= 0 then
		for i=1, #vexalarm.proclaims do
			local k=i-removes
			if vexalarm.proclaims[k][1]+vexalarm_parameters["timedata"]["show"]+vexalarm_parameters["timedata"]["vanish"]+0.2 <= currenttime then
				vexalarm.proclaims[k][2][1]:Hide()
				local place = vexalarm.proclaims[k][3]
				vexalarm.proclaimPlaces[place] = false
				table.remove(vexalarm.proclaims, k)
				removes = removes + 1
			end
		end
	end

	-- sort current proclaims
	if vexalarm_parameters["frame"]["allowscrolling"] and #vexalarm.proclaims ~= 0 then
		for i=1, #vexalarm.proclaims do
			vexalarm.proclaimPlaces[vexalarm.proclaims[i][3]] = false
			vexalarm.proclaimPlaces[i]=true
			vexalarm.proclaims[i][3] = i
			if vexalarm_parameters["frame"]["scrolldown"] then
				vexalarm.proclaims[i][2][2]:SetPoint("BOTTOMLEFT", vexalarm_frame_bg, "BOTTOMLEFT",
											vexalarm_parameters["frame"]["position"]["alarm"]["x"],
											(vexalarm_parameters["frame"]["position"]["alarm"]["spacing"]*i)-vexalarm_parameters["frame"]["position"]["alarm"]["y"])

			else
				vexalarm.proclaims[i][2][2]:SetPoint("TOPLEFT", vexalarm_frame_bg, "TOPLEFT",
											vexalarm_parameters["frame"]["position"]["alarm"]["x"],
											(-vexalarm_parameters["frame"]["position"]["alarm"]["spacing"]*i)+vexalarm_parameters["frame"]["position"]["alarm"]["y"])
			end
		end
	end
end

function vexalarm_generate_fulltext(alarmtype, spell, spellid, caster, target, status, msg)
	local statusstring = "inactive"
	if status then statusstring = "active" end
	
	local frame = CreateFrame("Frame", nil, vexalarm_frame_bg)
	frame:Show()
	local fontstring = frame:CreateFontString("frame", "ARTWORK", "GameFontNormal")
	
	--remove oldest proclaims when too many proclaims
	if #vexalarm.proclaims >= vexalarm_parameters["frame"]["maxevents"] then
		vexalarm.proclaims[1][2][1]:Hide()
		vexalarm.proclaimPlaces[vexalarm.proclaims[1][3]] = false
		table.remove(vexalarm.proclaims, 1)
	end
	local position = 0
	for i=1, #vexalarm.proclaimPlaces+1 do
		if not(vexalarm.proclaimPlaces[i]) and position == 0 then position = i end
	end
	vexalarm.proclaimPlaces[position] = true
	
	if vexalarm_parameters["frame"]["scrolldown"] then
		fontstring:SetPoint("BOTTOMLEFT", vexalarm_frame_bg, "BOTTOMLEFT",
									vexalarm_parameters["frame"]["position"]["alarm"]["x"],
									(vexalarm_parameters["frame"]["position"]["alarm"]["spacing"]*position)-vexalarm_parameters["frame"]["position"]["alarm"]["y"])

	else
		fontstring:SetPoint("TOPLEFT", vexalarm_frame_bg, "TOPLEFT",
									vexalarm_parameters["frame"]["position"]["alarm"]["x"],
									(-vexalarm_parameters["frame"]["position"]["alarm"]["spacing"]*position)+vexalarm_parameters["frame"]["position"]["alarm"]["y"])
	end
			
			
			
	fontstring:SetText(msg)
	fontstring:SetTextColor(vexalarm_parameters["frame"]["text"]["color"][statusstring]["r"],
						vexalarm_parameters["frame"]["text"]["color"][statusstring]["g"],
						vexalarm_parameters["frame"]["text"]["color"][statusstring]["b"],
						vexalarm_parameters["frame"]["text"]["color"][statusstring]["a"])
	fontstring:SetFont(vexalarm.LSM:Fetch("font", vexalarm_parameters["frame"]["text"]["font"]),
				vexalarm_parameters["frame"]["text"]["size"], vexalarm_parameters["frame"]["text"]["outline"])	
	fontstring:SetJustifyH(vexalarm_parameters["frame"]["text"]["align"])
	fontstring:SetWidth(vexalarm_parameters["frame"]["size"]["width"]-vexalarm_parameters["frame"]["position"]["alarm"]["x"])
	local newmsgframe_aniGRP = frame:CreateAnimationGroup("newmsgframe_aniGRP")
	newmsgframe_aniGRP:SetLooping("NONE")
	newmsgframe_ani = newmsgframe_aniGRP:CreateAnimation("Alpha")
	newmsgframe_ani:SetStartDelay(vexalarm_parameters["timedata"]["show"])
	newmsgframe_ani:SetOrder(1)
	newmsgframe_ani:SetSmoothing("IN")
		newmsgframe_ani:SetEndDelay(0)
		newmsgframe_aniGRP:SetScript("OnFinished", function (self) local frame = self:GetParent() frame:Hide() end)
		
	if status and vexalarm_spells_defaults[tostring(spellid)][7]~=nil then vexalarm_totem_new(alarmtype, spell, spellid, caster, target) end
	
	--adding fade-out-effect
	if vexalarm_parameters["timedata"]["allowvanish"] then
		newmsgframe_ani:SetDuration(vexalarm_parameters["timedata"]["vanish"])
		newmsgframe_ani:SetChange(-1)
	else
		newmsgframe_ani:SetDuration(0)
		newmsgframe_ani:SetChange(1)
	end
	newmsgframe_aniGRP:Play()
	
	vexalarm.proclaims[#vexalarm.proclaims+1] = {time(), {frame, fontstring, newmsgframe_aniGRP}, position}
end

function vexalarm_totem_new(alarmtype, spell, spellid, caster, target)
	vexalarm.totemsPlaced[spell]= {time(), {alarmtype, spellid, caster, target}}
end

function vexalarm_totem_clean()
	for key, val in pairs(vexalarm.totemsPlaced) do
		if val[1] + 360 < time() then vexalarm_totem_delete(key) end
	end
end

function vexalarm_totem_find(spell)
	local returnvalue = false
	if vexalarm.totemsPlaced[spell] ~= nil then returnvalue = true end
	return returnvalue
end

function vexalarm_totem_delete(spell)
	vexalarm.totemsPlaced[spell]= nil
end

function vexalarm_generate_singlealarm(alarmtype, spell, spellid, caster, target, status)
	--load custom msg
	local customalarm = ""
	local statusstring = "inactive"
	if status then statusstring = "active" end
	if 		alarmtype == "buff" 		then customalarm = vexalarm_parameters["msgs"]["buff"][statusstring]
	elseif 	alarmtype == "selfbuff"	  	then customalarm = vexalarm_parameters["msgs"]["selfbuff"][statusstring]
	elseif 	alarmtype == "grpbuff"	 	then customalarm = vexalarm_parameters["msgs"]["grpbuff"][statusstring]
	elseif 	alarmtype == "instant" 		then customalarm = vexalarm_parameters["msgs"]["instant"]
	elseif 	alarmtype == "instantself" 	then customalarm = vexalarm_parameters["msgs"]["instantself"]
	end
	
	--load custom status msg
	local statustext=vexalarm_parameters["msgs"]["status"][statusstring]
	
	-- change [spell]
	if spell ~= nil then
		customalarm = string.gsub(customalarm, "%[spell%]", spell)
		customalarm = string.gsub(customalarm, "%[spell_sc%]", vexalarm_colorize_specific(spell, 3))
		customalarm = string.gsub(customalarm, "%[spell_cc%]", vexalarm_colorize_class(spell, spellid, "spell"))
	end
	
	-- change [caster]
	if caster ~= nil then
		customalarm = string.gsub(customalarm, "%[caster%]", caster)
		customalarm = string.gsub(customalarm, "%[caster_sc%]", vexalarm_colorize_specific(caster, 1))
		customalarm = string.gsub(customalarm, "%[caster_cc%]", vexalarm_colorize_class(caster, spellid, "caster"))
	end
	
	-- change [target]
	if target ~= nil then
		customalarm = string.gsub(customalarm, "%[target%]", target)
		customalarm = string.gsub(customalarm, "%[target_sc%]", vexalarm_colorize_specific(target, 2))
		customalarm = string.gsub(customalarm, "%[target_cc%]", vexalarm_colorize_class(target, spellid, "target"))
	end
	
	-- change [statustext]
	if statustext ~= nil then
		customalarm = string.gsub(customalarm, "%[status%]", statustext)
		customalarm = string.gsub(customalarm, "%[status_sc%]", vexalarm_colorize_status(statustext, status))
		customalarm = string.gsub(customalarm, "%[status_cc%]", vexalarm_colorize_status(statustext, status))
	end
	return customalarm
end

function vexalarm_checkshow()
	if vexalarm_parameters["enable"] then
		if vexalarm_parameters["showonlyinfight"] and not(vexalarm.infight) then vexalarm.show = false
		else vexalarm.show = true end
	else vexalarm.show = false end
	
	if vexalarm.show then vexalarm_frame_bg:Show()
	else vexalarm_frame_bg:Hide() end
end

function vexalarm_myspellcheck(caster)
	local returnvalue = true
	if not(vexalarm_parameters["myspells"]) and caster==select(1, UnitName("player")) then returnvalue = false end	
	return returnvalue
end

function vexalarm_showgrpcheck(caster)
	local returnvalue = true
	if not(vexalarm_grpcheck(caster)) and vexalarm_parameters["showgrponly"] and caster~=select(1, UnitName("player")) then returnvalue = false end
	return returnvalue
end

function vexalarm_grpcheck(caster)
	local returnvalue = false
	returnvalue = UnitInRaid(caster)
	if not(returnvalue) then returnvalue = UnitInParty(caster) end
	return returnvalue
end

function vexalarm_getplayerrole(player)
	local returnvalue = 4
	if player ~= nil then
		local role = UnitGroupRolesAssigned(player);
		
		if role == "DAMAGER" then returnvalue = 3
		elseif role == "HEALER" then returnvalue = 2
		elseif role == "TANK" then returnvalue = 1
		else returnvalue = 4
		end
	end
	return returnvalue
end

function vexalarm_playSound(status, alarmtype)
	if vexalarm_parameters["sounds"]["allow"] and vexalarm.show then 
		if alarmtype == "instant" or alarmtype == "instantself" then 
			PlaySoundFile(vexalarm.LSM:Fetch("sound", vexalarm_parameters["sounds"]["cast"]["file"]), vexalarm_parameters["sounds"]["cast"]["channel"])
		else
			if status then 	PlaySoundFile(vexalarm.LSM:Fetch("sound", vexalarm_parameters["sounds"]["active"]["file"]), vexalarm_parameters["sounds"]["active"]["channel"])
			else 			PlaySoundFile(vexalarm.LSM:Fetch("sound", vexalarm_parameters["sounds"]["inactive"]["file"]), vexalarm_parameters["sounds"]["inactive"]["channel"]) end
		end
	end
end

function vexalarm_proclaim(alarmtype, spell, spellid,  caster, target, status)
	local msg = vexalarm_generate_singlealarm(alarmtype, spell, spellid, caster, target, status)
	if msg~="" then vexalarm_generate_fulltext(alarmtype, spell, spellid, caster, target, status, msg) vexalarm_playSound(status, alarmtype) end
end

function vexalarm_testproclaim_rndspell()
	local values = {}
	local contents = 0
	
	for key in pairs(vexalarm_spells_defaults) do
		contents = contents + 1
		values[contents] = key
	end
	
	local rndnumber = math.random(1,contents)
	
	return values[rndnumber]
end

function vexalarm_testproclaim()
	local spellid = vexalarm_testproclaim_rndspell()
	local alarmtype = vexalarm_spells_defaults[spellid][6]
	local spell = select(1, GetSpellInfo(tonumber(spellid)))
	local caster = select(1, UnitName("player"))
	local target = nil
	if alarmtype == "buff" or alarmtype == "instant" then target = caster end
	local status = {true, false}
	
	vexalarm_proclaim(alarmtype, spell, spellid, caster, target, status[math.random(1,2)])
end

function vexalarm_test_starter(val)
	if val and vexalarm.testmode then
		local frame = vexalarm_frame_bg
		local test_aniGRP = frame:CreateAnimationGroup("test_aniGRP")
		test_aniGRP:SetLooping("NONE")
		local test_ani = test_aniGRP:CreateAnimation("Scale")
		test_ani:SetOrder(1)
		test_ani:SetDuration(0)
		test_ani:SetScale(1,1)
		test_ani:SetEndDelay(math.random(1,3))
		test_aniGRP:SetScript("OnFinished", function () vexalarm_check_fulltext() vexalarm_test_starter(true) vexalarm_testproclaim() end)
		test_aniGRP:Play()
	end
end

function vexalarm_initialize(reload)
	vexalarm_loaddefaults(false)
	vexalarm_checkshow()
	vexalarm_set_frame_bg()
	if not(reload) then 
		vexalarm_optionpanel_OnLoad()
		for i=1,40 do
			if i<10 then	k = "0"..i
			else			k = ""..i end
			vexalarm.LSM:Register("sound", k, "Interface\\AddOns\\vexalarm\\sounds\\button_"..i..".ogg")
		end
		vexalarm.LSM:Register("border", "Solid", "Interface\\Buttons\\WHITE8X8")
		vexalarm.LSM:Register("font", "Emblem", "Interface\\AddOns\\vexalarm\\fonts\\EMBLEM.tff")
	end
end

function vexalarm_set_frame_bg()
	vexalarm_frame_bg:SetWidth(vexalarm_parameters["frame"]["size"]["width"])
	vexalarm_frame_bg:SetHeight(vexalarm_parameters["frame"]["size"]["height"])
	vexalarm_frame_bg:SetPoint("CENTER",
				UIParent,
				vexalarm_parameters["frame"]["position"]["bg"]["anchor"],
				vexalarm_parameters["frame"]["position"]["bg"]["x"],
				vexalarm_parameters["frame"]["position"]["bg"]["y"])
	vexalarm_frame_bg:SetBackdrop({bgFile=vexalarm.LSM:Fetch("background", vexalarm_parameters["frame"]["bg"]["texture"]),
								edgeFile=vexalarm.LSM:Fetch("border", vexalarm_parameters["frame"]["border"]["texture"]), tile=false,
								edgeSize=vexalarm_parameters["frame"]["border"]["size"]})
	vexalarm_frame_bg:SetBackdropColor(	vexalarm_parameters["frame"]["bg"]["color"]["r"],
										vexalarm_parameters["frame"]["bg"]["color"]["g"],
										vexalarm_parameters["frame"]["bg"]["color"]["b"],
										vexalarm_parameters["frame"]["bg"]["color"]["a"])
	vexalarm_frame_bg:SetBackdropBorderColor(	vexalarm_parameters["frame"]["border"]["color"]["r"],
												vexalarm_parameters["frame"]["border"]["color"]["g"],
												vexalarm_parameters["frame"]["border"]["color"]["b"],
												vexalarm_parameters["frame"]["border"]["color"]["a"])
end