function vexalarm.panel_field()
	return {
		type = "group",
		order= 3,
		args = {
			grptestmode = {
				name = vexalarm.Locale["test-mode grpname"],
				order=1, type ="group", dialogInline = true,
				args = {
					testmode = {
						name = vexalarm.Locale["activate test-mode"],
						order=1, type = "toggle", width="full",
						set = function(info,val) vexalarm.testmode=val vexalarm_test_starter(val) end,
						get = function() return vexalarm.testmode end,
						},
					testmodeinfo = {name = vexalarm.Locale["test-mode info"], type = "description", order=2, fontSize="medium"},
					},
				},
			frame_space_testmode = {name ="\n", type = "description", order=2},
			grppos = {
				name = vexalarm.Locale["field possize grpname"],
				order=10, type ="group", dialogInline = true,
				args = {
					framewidth = {
						name = vexalarm.Locale["field width"],
						order=1, type = "range",
						desc = vexalarm.Locale["field width desc"],
						step = 1, min = 1, max = 2000,
						set = function(info,val) vexalarm_parameters["frame"]["size"]["width"]=val vexalarm_initialize(true) end,
						get = function() return vexalarm_parameters["frame"]["size"]["width"] end
						},
					frameheight = {
						name = vexalarm.Locale["field height"],
						order=2, type = "range",
						desc = vexalarm.Locale["field height desc"],
						step = 1, min = 1, max = 2000,
						set = function(info,val) vexalarm_parameters["frame"]["size"]["height"]=val vexalarm_initialize(true) end,
						get = function() return vexalarm_parameters["frame"]["size"]["height"] end
						},
					frame_size_space = {name =" ", type = "description", order=3},
					frame_pos_x = {
						name = vexalarm.Locale["field x position"],
						order=6, type = "range",
						desc = vexalarm.Locale["field x position desc"],
						step = 1, min = -2000, max = 2000,
						set = function(info,val) vexalarm_parameters["frame"]["position"]["bg"]["x"]=val vexalarm_initialize(true) end,
						get = function() return vexalarm_parameters["frame"]["position"]["bg"]["x"] end
						},
					frame_pos_y = {
						name = vexalarm.Locale["field y position"],
						order=7, type = "range",
						desc = vexalarm.Locale["field y position desc"],
						step = 1, min = -2000, max = 2000,
						set = function(info,val) vexalarm_parameters["frame"]["position"]["bg"]["y"]=val vexalarm_initialize(true) end,
						get = function() return vexalarm_parameters["frame"]["position"]["bg"]["y"] end
						},
					frameanchor = {
						name = vexalarm.Locale["field anchor"],
						order=8, type = "select", style = "dropdown",
						desc = vexalarm.Locale["field anchor desc"],
						values = {
							["CENTER"]=vexalarm.Locale["field anchor center"],
							["BOTTOM"]=vexalarm.Locale["field anchor bottom"],
							["TOP"]=vexalarm.Locale["field anchor top"],
							["LEFT"]=vexalarm.Locale["field anchor left"],
							["RIGHT"]=vexalarm.Locale["field anchor right"],
							["BOTTOMLEFT"]=vexalarm.Locale["field anchor bottomleft"],
							["BOTTOMRIGHT"]=vexalarm.Locale["field anchor rottomright"],
							["TOPLEFT"]=vexalarm.Locale["field anchor topleft"],
							["TOPRIGHT"]=vexalarm.Locale["field anchor topright"]},
						set = function(self,key) vexalarm_parameters["frame"]["position"]["bg"]["anchor"]=key vexalarm_initialize(true) end,
						get = function() return vexalarm_parameters["frame"]["position"]["bg"]["anchor"] end,
						},
					},
				},
			frame_space1 = {name ="\n", type = "description", order=11},
				
			grpbg = {
				name = vexalarm.Locale["field bg grpname"],
				order=12, type ="group", dialogInline = true,
				args = {
					framebackdrop = {
						name = vexalarm.Locale["field bg texture"],
						order=1, type = "select",
						dialogControl = "LSM30_Background",
						values = vexalarm.LSM:HashTable("background"),
						set = function(self,key) vexalarm_parameters["frame"]["bg"]["texture"]=key vexalarm_initialize(true) end,
						get = function() return vexalarm_parameters["frame"]["bg"]["texture"] end,
						},
					bg_space = {name =" ", type = "description", order=2},
					framebgcolor = {
						name = vexalarm.Locale["field bg color"],
						order=3, type = "color",
						hasAlpha = false,
						set = function(info,r,g,b,a)
							vexalarm_parameters["frame"]["bg"]["color"]["r"]=r
							vexalarm_parameters["frame"]["bg"]["color"]["g"]=g
							vexalarm_parameters["frame"]["bg"]["color"]["b"]=b
							vexalarm_initialize(true) end,
						get = function() return
							vexalarm_parameters["frame"]["bg"]["color"]["r"],
							vexalarm_parameters["frame"]["bg"]["color"]["g"],
							vexalarm_parameters["frame"]["bg"]["color"]["b"] end,
						},
					framebgopacity = {
						name = vexalarm.Locale["opacity"].." %",
						order=4, type = "range",
						step = 5, min = 0, max = 100,
						set = function(info,val) vexalarm_parameters["frame"]["bg"]["color"]["a"]=val/100 vexalarm_initialize(true) end,
						get = function() return vexalarm_parameters["frame"]["bg"]["color"]["a"]*100 end
						},
					},
				},
			frame_space2 = {name ="\n", type = "description", order=13},
				
			grpborder = {
				name = vexalarm.Locale["field border grpname"],
				order=14, type ="group", dialogInline = true,
				args = {
					bordertexture = {
						name = vexalarm.Locale["field border texture"],
						order=1, type = "select",
						dialogControl = "LSM30_Border",
						values = vexalarm.LSM:HashTable("border"),
						set = function(self,key) vexalarm_parameters["frame"]["border"]["texture"]=key vexalarm_initialize(true) end,
						get = function() return vexalarm_parameters["frame"]["border"]["texture"] end,
						},
					bordersize = {
						name = vexalarm.Locale["field border size"],
						order=2, type = "range",
						step = 1, min = 0, max = 100,
						set = function(info,val) vexalarm_parameters["frame"]["border"]["size"]=val vexalarm_initialize(true) end,
						get = function() return vexalarm_parameters["frame"]["border"]["size"] end,
						},
					border_space = {name =" ", type = "description", order=3},
					bordercolor = {
						name = vexalarm.Locale["field border color"],
						order=4, type = "color",
						hasAlpha = false,
						set = function(info,r,g,b,a)
							vexalarm_parameters["frame"]["border"]["color"]["r"]=r
							vexalarm_parameters["frame"]["border"]["color"]["g"]=g
							vexalarm_parameters["frame"]["border"]["color"]["b"]=b
							vexalarm_initialize(true) end,
						get = function() return
							vexalarm_parameters["frame"]["border"]["color"]["r"],
							vexalarm_parameters["frame"]["border"]["color"]["g"],
							vexalarm_parameters["frame"]["border"]["color"]["b"] end,
						},
					frameborderopacity = {
						name = vexalarm.Locale["opacity"].." %",
						order=5, type = "range",
						step = 5, min = 0, max = 100,
						set = function(info,val) vexalarm_parameters["frame"]["border"]["color"]["a"]=val/100 vexalarm_initialize(true) end,
						get = function() return vexalarm_parameters["frame"]["border"]["color"]["a"]*100 end
						},
					}
				},
			},
		}
end