local vexalarm_profiles_profile_load = ""
local vexalarm_profiles_profile_delete = ""
local vexalarm_profiles_profile_new = GetRealmName().." "..select(1, UnitName("player"))

function vexalarm.panel_profiles()
	return {
		type = "group",
		args = {
			grpex = {
				name = vexalarm.Locale["profiles info grpname"],
				order=1, type = "group", dialogInline = true,
				args = {
					info1={name = vexalarm.Locale["profiles info"], type="description", order=2, fontSize="medium"},
					space1={name= " ", type="description", order=10},
					},
				},
			frame_space1 = {name =" ", type = "description", order=2},
			grpadd = {
				name = vexalarm.Locale["profiles add grpname"],
				order=3, type ="group", dialogInline = true,
				args = {
					profile_new = {
						name = vexalarm.Locale["profiles add name"],
						desc = vexalarm.Locale["profiles add name desc"],
						order=1, type = "input", multiline = false, width = "double",
						validate = function (info, val)
							if vexalarm_profile_checkName(val) then return true
							else return "ERROR - "..val.." is not a valid name" end
							end,
						set = function(info,val) vexalarm_profiles_profile_new = val end,
						get = function() return vexalarm_profiles_profile_new end,
						},
					profile_new_add = {
						name = vexalarm.Locale["profiles add button"], width="half",
						order=2, type = "execute",
						func = function(info,val) vexalarm_profile_add() end,
						},
					grpadddelete_allowed = {name = vexalarm.Locale["profiles add info"], type = "description", order=3, fontSize="medium"},
					},
				},
			frame_space2 = {name =" ", type = "description", order=4},
			grpdelete = {
				name = vexalarm.Locale["profiles delete grpname"],
				order=5, type ="group", dialogInline = true,
				args = {
					profile_delete = {
						name = vexalarm.Locale["profiles delete profile"],
						order=1, type = "select", style = "dropdown",
						values = vexalarm_profiles["profilelist"],
						set = function(self,key) vexalarm_profiles_profile_delete = key end,
						get = function() return vexalarm_profiles_profile_delete end,
						},
					delete_exe = {
						name = vexalarm.Locale["profiles delete button"],
						order=2, type = "execute",
						func = function(info,val) vexalarm_profile_delete() end,
						confirm = true,
						confirmText = vexalarm.Locale["profiles delete confirm"]
						},
					},
				},
			frame_space3 = {name =" ", type = "description", order=6},
			grpload = {
				name = vexalarm.Locale["profiles load grpname"],
				order=7, type ="group", dialogInline = true,
				args = {
					profile_load = {
						name = vexalarm.Locale["profiles load name"],
						order=1, type = "select", style = "dropdown",
						values = vexalarm_profiles["profilelist"],
						set = function(self,key) vexalarm_profiles_profile_load = key end,
						get = function() return vexalarm_profiles_profile_load end,
						},
					load_space = {name =" ", type = "description", order=2},
					load_exe_all = {
						name = vexalarm.Locale["profiles load button all"],
						desc = vexalarm.Locale["profiles load button all desc"],
						order=3, type = "execute", width="double",
						func = function(info,val) vexalarm_profile_load("all") vexalarm_initialize(true) end,
						},
					load_space2 = {name =" ", type = "description", order=4},
					load_exe_settings = {
						name = vexalarm.Locale["profiles load button settings"],
						order=5, type = "execute",
						func = function(info,val) vexalarm_profile_load("parameters") vexalarm_initialize(true) end,
						},
					load_exe_spells = {
						name = vexalarm.Locale["profiles load button spell-settings"],
						desc = vexalarm.Locale["profiles load button spell-settings desc"],
						order=6, type = "execute",
						func = function(info,val) vexalarm_profile_load("spells") vexalarm_initialize(true) end,
						},
					load_exe_spellprofiles = {
						name = vexalarm.Locale["profiles load button spell-profiles"],
						order=7, type = "execute",
						func = function(info,val) vexalarm_profile_load("spellprofiles") vexalarm_initialize(true) end,
						},
					},
				},
			}
		}
end

function vexalarm_profile_add()
	local key = vexalarm_profiles_profile_new
	if key ~= "" then
		vexalarm_profiles["profilelist"][key] = key
		
		if vexalarm_profiles[key] == nil then vexalarm_profiles[key] = {} end
		
		if vexalarm_profiles[key]["vexalarm_parameters"] == nil then vexalarm_profiles[key]["vexalarm_parameters"] = {} end
		vexalarm_profiles[key]["vexalarm_parameters"] = vexalarm_CopyTable(vexalarm_parameters)
		
		if vexalarm_profiles[key]["vexalarm_spellprofiles"] == nil then vexalarm_profiles[key]["vexalarm_spellprofiles"] = {} end
		vexalarm_profiles[key]["vexalarm_spellprofiles"] = vexalarm_CopyTable(vexalarm_spellprofiles)
		
		if vexalarm_profiles[key]["vexalarm_spells"] == nil then vexalarm_profiles[key]["vexalarm_spells"] = {} end
		vexalarm_profiles[key]["vexalarm_spells"] = vexalarm_CopyTable(vexalarm_spells)
		
		vexalarm_profiles_profile_new = ""
	end
end

function vexalarm_profile_delete(key)
	if key == nil then key = vexalarm_profiles_profile_delete end
	if key ~= "" then
		vexalarm_profiles["profilelist"][key] = nil
		vexalarm_profiles[key] = nil
	end
	vexalarm_profiles_profile_delete = ""
end

function vexalarm_profile_load(fragment)
	local key = vexalarm_profiles_profile_load
	if key ~= "" then
		if vexalarm_profiles[key] ~= nil then 
			if fragment == "all" then
				vexalarm_profile_load("parameters")
				vexalarm_profile_load("spellprofiles")
				vexalarm_profile_load("spells")
				vexalarm_profiles_profile_load = ""
			elseif fragment == "parameters" then
				vexalarm_parameters = vexalarm_CopyTable(vexalarm_profiles[key]["vexalarm_parameters"])
			elseif fragment == "spellprofiles" then
				for k,v in pairs (vexalarm_CopyTable(vexalarm_profiles[key]["vexalarm_spellprofiles"])) do
					if k ~="profilelist" then
						vexalarm_spellprofiles["profilelist"][k] = k
						vexalarm_spellprofiles[k] = vexalarm_CopyTable(v)
					end
				end
			elseif fragment == "spells" then
				vexalarm_spells = vexalarm_CopyTable(vexalarm_profiles[key]["vexalarm_spells"])
			end
		end
	end
end







