local vexalarm_spellprofiles_profile_load = ""
local vexalarm_spellprofiles_profile_delete = ""
local vexalarm_spellprofiles_profile_new = ""

function vexalarm.panel_spellprofiles()

	return {
		type = "group",
		args = {
			grpex = {
				name = vexalarm.Locale["profiles info grpname"],
				order=1, type = "group", dialogInline = true,
				args = {
					info1={name = vexalarm.Locale["spellprofiles info"], type="description", order=2, fontSize="medium"},
					space1={name= " ", type="description", order=10},
					},
				},
			frame_space1 = {name =" ", type = "description", order=2},
			grpadd = {
				name = vexalarm.Locale["profiles add grpname"],
				order=3, type ="group", dialogInline = true,
				args = {
					profile_new = {
						name = vexalarm.Locale["profiles add name"],
						desc = vexalarm.Locale["profiles add name desc"] ,
						order=1, type = "input", multiline = false, width = "double",
						validate = function (info, val)
							if vexalarm_profile_checkName(val) then return true
							else return "ERROR - "..val.." is not a valid name" end
							end,
						set = function(info,val) vexalarm_spellprofiles_profile_new = val end,
						get = function() return vexalarm_spellprofiles_profile_new end,
						},
					profile_new_add = {
						name = vexalarm.Locale["profiles add button"], width="half",
						order=2, type = "execute",
						func = function(info,val) vexalarm_spellprofile_add() end,
						},
					grpadddelete_allowed = {name =vexalarm.Locale["profiles add info"], type = "description", order=3, fontSize="medium"},
					},
				},
			frame_space2 = {name =" ", type = "description", order=4},
			grpdelete = {
				name = vexalarm.Locale["profiles delete grpname"],
				order=5, type ="group", dialogInline = true,
				args = {
					profile_delete = {
						name = vexalarm.Locale["profiles delete profile"],
						order=1, type = "select", style = "dropdown",
						values = vexalarm_spellprofiles["profilelist"],
						set = function(self,key) vexalarm_spellprofiles_profile_delete = key end,
						get = function() return vexalarm_spellprofiles_profile_delete end,
						},
					delete_exe = {
						name = vexalarm.Locale["profiles delete button"],
						order=2, type = "execute",
						func = function(info,val) vexalarm_spellprofile_delete() end,
						confirm = true,
						confirmText = vexalarm.Locale["profiles delete confirm"]
						},
					},
				},
			frame_space3 = {name =" ", type = "description", order=6},
			grpload = {
				name = vexalarm.Locale["profiles load grpname"],
				order=7, type ="group", dialogInline = true,
				args = {
					profile_load = {
						name = vexalarm.Locale["profiles load name"],
						order=1, type = "select", style = "dropdown",
						values = vexalarm_spellprofiles["profilelist"],
						set = function(self,key) vexalarm_spellprofiles_profile_load = key end,
						get = function() return vexalarm_spellprofiles_profile_load end,
						},
					load_exe = {
						name = vexalarm.Locale["spellprofiles load button"],
						order=2, type = "execute",
						func = function(info,val) vexalarm_spellprofile_add() vexalarm_initialize(true) end,
						},
					grpload_info = {name = vexalarm.Locale["spellprofiles load info"], type = "description", order=3, fontSize="medium"},
					},
				},
			}
		}
end

function vexalarm_profile_checkName(val)
	local returnvalue = false
	local val_edited = string.gsub(val, "%a", "")
	val_edited = string.gsub(val_edited, "%d", "")
	val_edited = string.gsub(val_edited, " ", "")
	if val_edited == "" then returnvalue = true end
	if val == "" or val == "profilelist" then returnvalue = false end
	return returnvalue
end

function vexalarm_spellprofile_add()
	local key = vexalarm_spellprofiles_profile_new
	if key ~= "" then
		vexalarm_spellprofiles["profilelist"][key] = key
		vexalarm_spellprofiles[key] = vexalarm_CopyTable(vexalarm_spells)
		vexalarm_spellprofiles_profile_new = ""
		debugs.print(vexalarm_spellprofiles["profilelist"], 'vexalarm_spellprofiles["profilelist"]')
	end
end

function vexalarm_spellprofile_delete(key)
	if key == nil then key = vexalarm_spellprofiles_profile_delete end
	if key ~= "" then
		vexalarm_spellprofiles["profilelist"][key] = nil
		vexalarm_spellprofiles[key] = nil
	end
	vexalarm_spellprofiles_profile_delete = ""
end

function vexalarm_spellprofile_load(key, slashcmd)
	if key == nil then key = vexalarm_spellprofiles_profile_load end
	if key ~= "" then
		if vexalarm_spellprofiles[key] == nil then print("|CFFFF7D0AVex Alarm|r - "..vexalarm.Locale["spellprofiles profile not found"])
		else
			vexalarm_spells = vexalarm_CopyTable(vexalarm_spellprofiles[key])
			if slashcmd then print("|CFFFF7D0AVex Alarm|r - "..vexalarm.Locale["spellprofiles profile loaded 1"].." '"..key.."' "..vexalarm.Locale["spellprofiles profile loaded 2"]) end
		end
	end
	vexalarm_spellprofiles_profile_load = ""
end

-- thx to Lombra from WoWAce for this function
function vexalarm_CopyTable(settings)
	local copy = {}
	for k, v in pairs(settings) do
		if type(v) == "table" then  copy[k] = vexalarm_CopyTable(v)
		else						copy[k] = v end
	end
	return copy
end



