vexalarm = {}
vexalarm.AceConfigDialog = LibStub("AceConfigDialog-3.0", true)
vexalarm.AceConfig = LibStub("AceConfig-3.0", true)
vexalarm.AceConsole= LibStub("AceConsole-3.0", true)
vexalarm.LSM = LibStub("LibSharedMedia-3.0", true)
vexalarm.LSMWidgets = LibStub("AceGUI-3.0-SharedMediaWidgets", true)
vexalarm.Locale = LibStub("AceLocale-3.0"):GetLocale("Vex Alarm")

--Start values
vexalarm.infight = false
vexalarm.last_spell_id = ""
vexalarm.last_spell_timestamp = 0
vexalarm.last_spell_event = ""
vexalarm.last_spell_caster = ""
vexalarm.proclaims = {}
vexalarm.proclaimPlaces = {}
vexalarm.show = true
vexalarm.loadings = 0
vexalarm.totemsPlaced = {}
vexalarm.testmode = false

SLASH_VEXALARM1 = "/vexalarm"
SLASH_VEXALARM2 = "/vexa"
function SlashCmdList.VEXALARM(msg, editbox)
	local command, args = msg:match("^(%S*)%s*(.-)$")
	
	if command == "" or command == "option" or command == "options" or command == "config" or command == "configs" then InterfaceOptionsFrame_OpenToCategory(vexalarm_optionpanel)
	elseif command == "print" 		then vexalarm_print_spells()
	elseif command == "profile" 	then vexalarm_spellprofile_load(args, true)
	elseif command == "defaults" 	then print("|CFFFF7D0AVex Alarm|r - "..vexalarm.Locale["print defaults loaded"]) 	vexalarm_loaddefaults(true)
	elseif command == "enable" 		then vexalarm_parameters["enable"]=not(vexalarm_parameters["enable"]) vexalarm_checkshow()
										 if vexalarm_parameters["enable"] then  print("|CFFFF7D0AVex Alarm|r - Addon "..vexalarm.Locale["print addon enabled"])
										 else									print("|CFFFF7D0AVex Alarm|r - Addon "..vexalarm.Locale["print addon disabled"]) end
	else
		print ("|CFFFF7D0AVex Alarm|r "..vexalarm.Locale["print cmd not found"])
		print ("|CFFFF7D0A/vexalarm|r "..vexalarm.Locale["print slashs useable"])
		print ("|CFFFF7D0A/vexalarm|r option/options/config/configs - "..vexalarm.Locale["print slashs options"])
		print ("|CFFFF7D0A/vexalarm|r defaults - "..vexalarm.Locale["print slashs defaults"])
		print ("|CFFFF7D0A/vexalarm|r profile "..vexalarm.Locale["print slashs profile"])
		print ("|CFFFF7D0A/vexalarm|r enable - "..vexalarm.Locale["print slashs enable"])
	end
end

function vexalarm_OnEvent(self, event, ...)
	if event == "PLAYER_LOGIN" then
		vexalarm_initialize()
		print("|CFFFF7D0AVex Alarm|r loaded")
	elseif event == "PLAYER_ENTER_COMBAT" then
		vexalarm.infight = true
		vexalarm_checkshow()
	elseif event == "PLAYER_LEAVE_COMBAT" then
		vexalarm.infight = false
		vexalarm_checkshow()
	else
		if vexalarm.show then
			vexalarm_check_fulltext()
			local eventchar  = select(2, ...)
			if eventchar == "SPELL_AURA_APPLIED" or eventchar == "SPELL_CAST_SUCCESS" or eventchar == "SPELL_AURA_REMOVED" or eventchar == "SPELL_SUMMON" or eventchar == "SPELL_RESURRECT" then
				local caster = select(5, ...)
				local spellid = select(12, ...)
				local spellname = select(13, ...)
				local target = select(9, ...)
				-- debugs.print({spellid, spellname}, "spell")
				-- debugs.print(eventchar, "eventchar")
				if vexalarm_myspellcheck(caster) and vexalarm_showgrpcheck(caster) then
					alarmtype = vexalarm_spellcheck(spellid, caster, eventchar)
					if(alarmtype ~="" and alarmtype ~="dejavue") then
						vexalarm_proclaim(alarmtype, spellname, spellid, caster, target, eventchar == "SPELL_AURA_APPLIED" or eventchar == "SPELL_CAST_SUCCESS" or eventchar == "SPELL_SUMMON" or eventchar == "SPELL_RESURRECT")
					end
				end
			elseif eventchar == "UNIT_DESTROYED" then
				--totemcheck
				vexalarm_totem_clean()
				
				local spellname = select(9, ...)
				if vexalarm_totem_find(spellname) then
					local alarmtype = vexalarm.totemsPlaced[spellname][2][1]
					local spellid = vexalarm.totemsPlaced[spellname][2][2]
					local caster = vexalarm.totemsPlaced[spellname][2][3]
					local target = vexalarm.totemsPlaced[spellname][2][4]
					if vexalarm_myspellcheck(caster) and vexalarm_showgrpcheck(caster) then
						vexalarm_proclaim(alarmtype, spellname, spellid, caster, target, false)
						vexalarm_totem_delete(spellname)
					end
				end
			end
		end
	end
end
